import { Program, Element } from "assemblyscript";
import { IMetadataVersioned } from "contract-metadata";
import * as metadata from "contract-metadata";
export declare const LANGUAGE: string;
export declare const COMPILER: string;
export declare class MetadataGenerator {
    readonly program: Program;
    readonly contractConfig: metadata.IContract;
    private entrypoint;
    private events;
    constructor(program: Program, contractConfig: metadata.IContract);
    generate(): IMetadataVersioned;
    private genSpec;
    private genTypes;
    private genCompositeType;
    private genMessages;
    private genConstructors;
    private genEvents;
    private genEventSpec;
    private getFuncArgumentSpecs;
}
/**
 * Find the entrypoint contract, we begin analysis from entrypoint
 * @param elem
 * @returns
 */
export declare function isEntrypointContract(elem: Element): boolean;
export declare function isContract(elem: Element): boolean;
export declare function isConstructor(elem: Element): boolean;
export declare function isMessage(elem: Element): boolean;
export declare function isEvent(elem: Element): boolean;
