import { TransformVisitor } from "visitor-as";
import { DiagnosticEmitter, TypeDeclaration } from "assemblyscript";
import { EnvConfig } from "../config";
/**
 * EnvTypeVisitor is used to transform all env types to confiured types.
 * It should be used only inside `@contract` class and `@storage` class.
 */
export declare class EnvTypeVisitor extends TransformVisitor {
    readonly emitter: DiagnosticEmitter;
    readonly config: EnvConfig;
    constructor(emitter: DiagnosticEmitter, config: EnvConfig);
    visitTypeDeclaration(node: TypeDeclaration): TypeDeclaration;
}
