import { TransformVisitor } from "visitor-as";
import { TypeDeclaration, Parser, ClassDeclaration, Source, Module } from "assemblyscript";
/**
 * AskTransform is the entrypoint of all other visitors.
 */
export declare class AskTransform extends TransformVisitor {
    private readonly config;
    private readonly mode;
    private envReplacer;
    private parser;
    private deployFunction;
    private callFunction;
    private hasAskDecorator;
    private isEntrypoint;
    private readonly askSources;
    private readonly events;
    constructor();
    private genContract;
    private genSpreadLayout;
    private genPackedLayout;
    private genEvent;
    visitClassDeclaration(node: ClassDeclaration, _isDefault?: boolean): ClassDeclaration;
    visitTypeDeclaration(node: TypeDeclaration): TypeDeclaration;
    visitSource(node: Source): Source;
    afterParse(parser: Parser): void;
    afterCompile(_module: Module): void;
}
